package com.casic.missiles.service.business;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.casic.missiles.dto.BaseApprovalSubmitRequest;
import com.casic.missiles.dto.ReturnDTO;
import com.casic.missiles.dto.business.certificate.CertificateMonitorResponse;
import com.casic.missiles.dto.business.certificate.CertificateReportApprovalRequest;
import com.casic.missiles.dto.business.certificate.CertificateReportResponse;
import com.casic.missiles.dto.customer.CertificationResponse;
import com.casic.missiles.dto.customer.sample.CustomerSampleIdRequest;
import com.casic.missiles.dto.flowable.ApprovalDeleteRequest;
import com.casic.missiles.model.business.BusinessCertificateReport;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * <p>
 * 业务管理-证书报告 服务类
 * </p>
 *
 * @author zt
 * @since 2023-02-02
 */
public interface IBusinessCertificateReportService extends IService<BusinessCertificateReport> {

    ReturnDTO saveCertificateReport(BusinessCertificateReport certificateReport);

    BusinessCertificateReport certificateReportDetail(Long id);

    List<CertificateReportResponse> approvalListPage(Page<CertificateReportResponse> page, CertificateReportApprovalRequest request);

    ReturnDTO approvalDelete(ApprovalDeleteRequest request);

    ReturnDTO deleteBatchTraceSupplier(List<Long> ids);

    ReturnDTO submitCertificateReport(BaseApprovalSubmitRequest request);

    ReturnDTO failUpdate(BusinessCertificateReport certificateReport);

    ReturnDTO draftUpdate(BusinessCertificateReport certificateReport);

    void originExport(CertificateReportApprovalRequest request, HttpServletResponse response);

    boolean updateCertificateReportState(Long id);

    Page<CertificateMonitorResponse> certificateMonitorsById(CustomerSampleIdRequest customerSampleIdRequest) throws Exception;

    Page<CertificationResponse> certificateRecordsById(CustomerSampleIdRequest customerSampleIdRequest) throws Exception;
}
